Você não pode selecionar mais de 25 tópicos Os tópicos devem começar com uma letra ou um número, podem incluir traços ('-') e podem ter até 35 caracteres.
 
 
 
 
 
 

1310 linhas
30 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __lf=$'\n'
  21. __cr=$'\r'
  22. # For normal cases TMP is set in ./profile
  23. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  24. mkdir -p "$TMP"
  25. __homerun="$HOME/.var/run"
  26. mkdir -p "$__homerun"
  27. ##########################
  28. # system type
  29. gnu_coreutils=false # for mac
  30. null ls --version && gnu_coreutils=true
  31. inbash=false
  32. inzsh=false
  33. if test -n "$BASH_VERSION"
  34. then
  35. inbash=true
  36. elif test -n "$ZSH_VERSION"
  37. then
  38. inzsh=true
  39. fi
  40. #################################
  41. # file pathes:
  42. # shrc: Path to this file
  43. if $inbash
  44. then
  45. __shrc="$BASH_SOURCE"
  46. elif $inzsh
  47. then
  48. __shrc="$0"
  49. fi
  50. #########################
  51. # system detection
  52. __system_shrc="$__homerun/system.shrc"
  53. if test -f "$__system_shrc"
  54. then
  55. . "$__system_shrc"
  56. else
  57. ismsys=false
  58. iscygwin=false
  59. iswindows=false
  60. isdarwin=false
  61. isfreebsd=false
  62. isbsd=false
  63. islinux=false
  64. # $OSTYPE is another choice. which is better?
  65. # NOTE: sh on FreeBSD does not define OSTYPE
  66. case `uname` in
  67. MINGW*) ismsys=true ;;
  68. CYGWIN*) iscygwin=true ;;
  69. Darwin*) isdarwin=true ;;
  70. FreeBSD*) isfreebsd=true ;;
  71. Linux*) islinux=true ;;
  72. esac
  73. ($ismsys || $iscygwin) && iswindows=true
  74. # is this true?
  75. ($isdarwin || $isfreebsd) && isbsd=true
  76. # dump system detection result
  77. cat <<__EOC__ >"$__system_shrc"
  78. #!/bin/sh
  79. # $__system_shrc
  80. ismsys=$ismsys
  81. iscygwin=$iscygwin
  82. iswindows=$iswindows
  83. isdarwin=$isdarwin
  84. isfreebsd=$isfreebsd
  85. isbsd=$isbsd
  86. islinux=$islinux
  87. __EOC__
  88. fi
  89. $ismsys && export HOSTNAME
  90. # adhoc fix for ansible on cygwin
  91. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  92. if $iscygwin
  93. then
  94. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  95. fi
  96. ##########################
  97. # Terminal setups
  98. if ! $iswindows && null type stty
  99. then
  100. stty stop undef # unbind C-s to stop displaying output
  101. # stty erase '^h'
  102. fi
  103. if $inbash
  104. then
  105. # https://unix.stackexchange.com/questions/1288/preserve-bash-history-in-multiple-terminal-windows
  106. # Avoid duplicates
  107. HISTCONTROL=ignoredups:erasedups
  108. # When the shell exits, append to the history file instead of overwriting it
  109. shopt -s histappend
  110. fi
  111. # Zsh specific preferences
  112. # http://www.clear-code.com/blog/2011/9/5.html
  113. if $inzsh
  114. then
  115. bindkey -e
  116. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  117. autoload compinit; compinit
  118. # supress cycle by tab
  119. unsetopt auto_menu
  120. # unsetopt correct
  121. setopt complete_aliases
  122. setopt auto_list
  123. setopt bash_auto_list
  124. setopt magic_equal_subst
  125. setopt list_types
  126. # what is the difference of these two?
  127. setopt auto_param_slash
  128. setopt mark_dirs
  129. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  130. zstyle ':completion:*' format '%B%d%b'
  131. zstyle ':completion:*' group-name ''
  132. zstyle ':completion:*' use-cache yes
  133. # zstyle ':completion:*:cd:*' tag-order local-directories
  134. zstyle ':completion:*' completer _complete _bash_completions \
  135. _history
  136. # zstyle ':completion:*:*:cd:*' completer
  137. zstyle ':completion:*' accept-exact-dirs true
  138. zstyle ':completion:*' special-dirs true
  139. autoload colors; colors
  140. # autoload -Uz promptinit
  141. # promptinit
  142. # prompt walters
  143. setopt hist_ignore_dups
  144. setopt hist_ignore_all_dups
  145. setopt hist_save_no_dups
  146. setopt extended_history
  147. setopt share_history
  148. setopt append_history
  149. HISTFILE=$HOME/.zsh-history
  150. HISTSIZE=100000
  151. SAVEHIST=100000
  152. setopt prompt_subst
  153. setopt interactive_comments
  154. fi
  155. ######################
  156. # Print welcome messages
  157. if command -v lolcat >/dev/null
  158. then
  159. alias __safe_lolcat=lolcat
  160. else
  161. alias __safe_lolcat=cat
  162. fi
  163. if command -v cowsay >/dev/null
  164. then
  165. alias __safe_cowsay=cowsay
  166. else
  167. alias __safe_cowsay=cat
  168. fi
  169. command -v fortune >/dev/null && {
  170. fortune | __safe_cowsay | __safe_lolcat
  171. echo
  172. fortune -o | __safe_cowsay | __safe_lolcat
  173. echo
  174. }
  175. uname -a
  176. $iswindows && alias tty="echo cmd.exe"
  177. echo TERM $TERM with $(tput colors) colors using $(tty)
  178. echo umask: `umask -S`
  179. # if null type figlet && null type lolcat
  180. # then
  181. # echo `whoami`@`hostname` | figlet | lolcat
  182. # fi
  183. # echo
  184. if command -v neofetch >/dev/null
  185. then
  186. neofetch
  187. elif command -v screenfetch >/dev/null
  188. then
  189. screenfetch
  190. fi
  191. __safe_run id `whoami`
  192. # echo
  193. ## A bit heavy command
  194. # finger `whoami`
  195. echo
  196. __safe_run w `whoami`
  197. # if null type tmux
  198. # then
  199. # echo
  200. # echo tmux sessions:
  201. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  202. # echo
  203. # fi
  204. # if test -n "$TMUX"
  205. # then
  206. # tmux display -p \
  207. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  208. # 2>/dev/null
  209. # echo
  210. # fi
  211. if test -n "$__MY_DTACH"
  212. then
  213. echo
  214. echo DSession: Current Session: "`basename "$__MY_DTACH"`"
  215. echo DSession: Press C-^ to Exit.
  216. true
  217. fi
  218. i(){
  219. w
  220. ss -lnp
  221. ps aufx
  222. df -h
  223. top -b -d 1 -n 1
  224. top -b -d 1 -n 1 -a
  225. dstat -taf 1 10
  226. }
  227. ###################################
  228. # some aliases and functions
  229. # __func_name: never used interactively
  230. # _func_name: usually not used interactively
  231. __safe_alias(){
  232. # __safe_alias <name>=<command>
  233. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  234. test -n "$_bin" && \
  235. null type $_bin && \
  236. alias "$1"
  237. }
  238. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  239. # color prefs
  240. if $gnu_coreutils
  241. then
  242. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  243. # gnu coreutils LS_COLORS is used
  244. null type dircolors && eval `dircolors`
  245. _coloroption=" --color=auto"
  246. else
  247. # export LSCOLORS=gxfxcxdxbxegedabagacad
  248. export LSCOLORS=DxGxcxdxCxegedabagacad
  249. export CLICOLOR=1
  250. fi
  251. alias ls="ls -hCF${_coloroption}${_timeoption}"
  252. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  253. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  254. _timeformat_num="%Y%m%d%H%M%S"
  255. alias datenum="date +$_timeformat_num"
  256. alias less="less -FX"
  257. __safe_alias em="emacs -nw"
  258. test -n "$_VI_ALT" && alias vi=$_VI_ALT
  259. alias pstree="LANG=C pstree"
  260. alias cp="cp -v"
  261. alias mv="mv -v"
  262. alias rm="rm -v"
  263. alias mkdir="mkdir -v"
  264. $gnu_coreutils && alias rmdir="rmdir -v"
  265. alias psaux="ps auxww"
  266. alias modest="ionice -c 2 -n 7 nice -n 19"
  267. alias e=exec
  268. __safe_alias e3=e3em
  269. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  270. alias po=popd
  271. alias pu=pushd
  272. __safe_alias sudoe="sudoedit"
  273. __safe_alias ge="git exec"
  274. __safe_alias make="nice make"
  275. __safe_alias brew="nice brew"
  276. __safe_alias gcc="nice gcc"
  277. __safe_alias go="nice go"
  278. __safe_alias git="nice git"
  279. __safe_alias javac="nice javac -J-Duser.language=en"
  280. __safe_alias ansible-playbook="nice ansible-playbook"
  281. alias rand="echo \$RANDOM"
  282. alias pycalc="python -i -c 'from math import *' "
  283. __safe_alias py3=python3
  284. __safe_alias py2=python2
  285. __safe_alias ipy=ipython
  286. __safe_alias ipy3=ipython3
  287. __safe_alias ipy2=ipython2
  288. __safe_alias rl=rlwrap
  289. __safe_alias igosh=gosh-rl
  290. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  291. # SHELL is set to be /bin/zsh
  292. if $inbash
  293. then
  294. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  295. elif $inzsh
  296. then
  297. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  298. else
  299. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  300. fi
  301. # alias mytime="date +%Y%m%d-%H%M%S"
  302. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  303. # some extra utilities
  304. __safe_alias mpg123="mpg123 -C -v --title"
  305. #export PLAYER="mpg123 -C -v --title"
  306. __safe_alias screen="screen -e^z^z"
  307. #alias zcd="cd \`zenity --file-selection --directory\`"
  308. __safe_alias gtags="gtags --verbose"
  309. __safe_alias htags="htags --xhtml --symbol --line-number \
  310. --frame --alphabet --verbose"
  311. __safe_alias au=aunpack
  312. # __safe_alias lv="lv|less"
  313. __safe_alias rs="rsync --progress --itemize-changes --compress"
  314. __safe_alias vagr=vagrant
  315. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  316. if $iscygwin
  317. then
  318. __my_wget_options=" --no-check-certificate"
  319. __safe_alias wget="wget $__my_wget_options"
  320. fi
  321. if $isdarwin
  322. then
  323. alias updatedb="LC_ALL=C updatedb"
  324. # do not use locate installed by macports
  325. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  326. fi
  327. # somehow not work
  328. # typeset -ga chpwd_functions
  329. # chpwd_functions+=pwd
  330. # chpwd(){
  331. # pwd
  332. # }
  333. cd(){
  334. builtin cd "$@" && pwd
  335. }
  336. root(){
  337. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  338. then
  339. cd "`git rev-parse --show-toplevel`"
  340. else
  341. cd /
  342. fi
  343. }
  344. __find_latest_vimdir(){
  345. vimdir=/usr/share/vim
  346. if test -d "$vimdir"
  347. then
  348. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  349. else
  350. echo ""
  351. fi
  352. }
  353. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  354. do
  355. test -n "$f" || continue
  356. f="$f/macros/less.sh"
  357. test -f $f && alias vl=$f && break
  358. done
  359. __safe_alias pa="pacman --color=always"
  360. __safe_alias pa="pacmatic --color=always"
  361. __safe_alias pa="pacapt"
  362. __safe_alias yt=yaourt
  363. # variable for yaourt
  364. null type pacmatic && export PACMAN="pacmatic"
  365. __safe_alias cower="cower --color=auto"
  366. __my_pacman_update_mirrorlist_with_reflector(){
  367. f=/etc/pacman.d/mirrorlist
  368. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  369. if test -z "$cmd"
  370. then
  371. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  372. fi
  373. echo ">>> $cmd ..." 1>&2
  374. sudo sh -c "$cmd" && cat $f
  375. }
  376. null type reflector && test -d /etc/pacman.d && \
  377. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  378. null type apt-get && {
  379. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  380. apt-get update --yes && apt-get upgrade --yes'"
  381. alias aptin="apt-get install"
  382. alias aptsearch="apt-cache search"
  383. alias aptshow="apt-cache show"
  384. }
  385. null type port && {
  386. alias port="port -v"
  387. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  388. port -v upgrade outdated'"
  389. }
  390. if $iscygwin
  391. then
  392. null type windate || \
  393. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  394. # alias cygsu="cygstart /cygwinsetup.exe"
  395. fi
  396. mkpatch(){
  397. if test $# -eq 0
  398. then
  399. echo "usage: mkpatch <olddir> <newdir>"
  400. elif ! test -d "$1"
  401. then
  402. echo "mkpatch: $1 is not a directory"
  403. elif ! test -d "$2"
  404. then
  405. echo "mkpatch: $2 is not a directory"
  406. else
  407. diff -Naur "$1" "$2"
  408. fi
  409. }
  410. __sdcv_less(){
  411. command sdcv -n "$@" | less --quit-if-one-screen
  412. }
  413. command -v sdcv >/dev/null && alias dict=__sdcv_less
  414. __safe_alias g="git "
  415. if null type _git && $inbash
  416. then
  417. # enable programmable completion for g
  418. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  419. || complete -o default -o nospace -F _git g
  420. fi
  421. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  422. __safe_alias m=gitmemo
  423. #alias setup.py3="sudo python3 setup.py install --record files.txt"
  424. randomstr(){
  425. len=$1
  426. test -z "$len" && len=8
  427. uuidgen | tr -d - | cut -c 1-len
  428. }
  429. datestr(){
  430. # datestr YYYYMMDDhhmmss
  431. if test -z "$1" || test "$1" = "-h"
  432. then
  433. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  434. return 1
  435. fi
  436. # actual format for date command
  437. dfmt="`echo "$1" | \
  438. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  439. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  440. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  441. date +"$dfmt"
  442. }
  443. # ssh(){
  444. # # __my_terminal_title ssh
  445. # command ssh "$@"
  446. # }
  447. __ssh_with_cd(){
  448. # __ssh_with_cd <host> <directory> [<arg> ...]
  449. if test -z "$2"
  450. then
  451. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  452. return 1
  453. fi
  454. host="$1"
  455. shift
  456. dir="$1"
  457. shift
  458. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  459. }
  460. memo(){
  461. if test -z "$1"
  462. then
  463. _memo="memo.txt"
  464. else
  465. _memo="$1/memo.txt"
  466. fi
  467. $EDITOR "$_memo"
  468. if test -z "`cat "$_memo"`"
  469. then
  470. echo "$_memo is empty. Removing."
  471. rm "$_memo"
  472. fi
  473. }
  474. now(){
  475. ___tformat="%Y/%m/%d %H:%M:%S %z"
  476. cal
  477. REPLY=
  478. printf "\\r`date "+${___tformat}"`"
  479. read -t 1
  480. while test $? -ne 0
  481. do
  482. printf "\\r`date "+${___tformat}"`"
  483. read -t 1
  484. done
  485. }
  486. s(){
  487. if git rev-parse --git-dir >/dev/null 2>&1
  488. then
  489. echo ">> git grep -n $@" 1>&2
  490. git grep -n "$@"
  491. elif which ag >/dev/null 2>&1
  492. then
  493. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  494. ag --pager="$PAGER" "$@"
  495. elif which ack >/dev/null 2>&1
  496. then
  497. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  498. ack --pager="$PAGER" "$@"
  499. else
  500. echo \
  501. ">> find . " \
  502. "-path '*/.git' -prune -o" \
  503. "-path '*/.svn' -prune -o" \
  504. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  505. if test $# -eq 0
  506. then
  507. echo "No search word given." 1>&2
  508. return 1
  509. fi
  510. find . \
  511. -path '*/.git' -prune -o \
  512. -path '*/.svn' -prune -o \
  513. -type -f -exec grep -nH -e --color=always "$@" {} + \
  514. | $PAGER
  515. fi
  516. }
  517. MYMANPATH='/usr/lib/erlang/man'
  518. if $inbash || $inzsh
  519. then
  520. man(){
  521. env \
  522. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  523. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  524. LESS_TERMCAP_me=$(printf "\e[0m") \
  525. LESS_TERMCAP_se=$(printf "\e[0m") \
  526. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  527. LESS_TERMCAP_ue=$(printf "\e[0m") \
  528. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  529. MANPATH="`manpath`:$MYMANPATH" \
  530. man "$@"
  531. }
  532. fi
  533. netwait(){
  534. while ! ping -c 1 -t 1 example.com
  535. do
  536. true
  537. done
  538. echo network works.
  539. }
  540. __realpath(){
  541. if type realpath >/dev/null 2>&1
  542. then
  543. command realpath "$@"
  544. else
  545. while ! test -d $1
  546. do
  547. shift
  548. done
  549. (command cd "$d" && echo "$PWD")
  550. # local d="$OLDPWD"
  551. # command cd "$1"
  552. # echo "$PWD"
  553. # command cd "$d"
  554. fi
  555. }
  556. if $isdarwin
  557. then
  558. # I want to use env -u, but darwin env does not provide this option
  559. null type tmux && alias tmux='SHLVL= tmux'
  560. else
  561. null type tmux && alias tmux='env -u SHLVL tmux'
  562. fi
  563. tx(){
  564. tmux start-server
  565. if test -z "$1"
  566. then
  567. echo "usage: tx [<session_name>]"
  568. tmux list-sessions
  569. elif test -z "$TMUX"
  570. then
  571. # -A: attach if already exists
  572. # tmux new-session -A -c "$HOME" -s "$1"
  573. tmux new-session -A -s "$1"
  574. else
  575. # create new session if not exists yet
  576. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  577. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  578. tmux switch-client -t "$1"
  579. fi
  580. }
  581. __dsession(){
  582. # dt [-h] [<name>] [<command ...>]
  583. __dtach_dir="${TMP}/dtach"
  584. mkdir -p "${__dtach_dir}"
  585. if test -n "${__MY_DTACH}"
  586. then
  587. # if already in dtach session print current session
  588. soc_name="`basename "$__MY_DTACH"`"
  589. echo "Current session: ${soc_name}"
  590. fi
  591. if test -z "$1"
  592. then
  593. # if no arg given show list of sessions
  594. echo "Usage: ds [<session>]"
  595. echo "Sessions:"
  596. ls "${__dtach_dir}"
  597. return 0
  598. elif test "$1" = "-h"
  599. then
  600. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  601. return 1
  602. fi
  603. # set socket name
  604. soc_name="${__dtach_dir}/$1"
  605. shift
  606. if test -n "$__MY_DTACH"
  607. then
  608. echo "dtach session cannot be nested." 1>&2
  609. return 1
  610. elif test -S "$soc_name"
  611. then
  612. dtach -a "$soc_name" -e ^^
  613. elif test -e "$soc_name"
  614. then
  615. echo "dt: File named $soc_name already exists."
  616. return 1
  617. elif test -z "$1"
  618. then
  619. # if no command given invoke current shell
  620. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  621. # echo "dt: Socket named $soc_name not exists and no command specified."
  622. # return 1
  623. else
  624. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  625. fi
  626. }
  627. null type dtach && alias ds=__dsession
  628. scr(){
  629. test -n "$1" && pf="${1}-"
  630. ___tformat="%Y%m%d-%H%M%S%z"
  631. ___file="${PWD}/${pf}`date +${___tformat}`.script"
  632. __MY_SCRIPT=${___file} script ${___file} "$@"
  633. }
  634. dtscr(){
  635. # dtscr <command ...>
  636. if test -z "$1"
  637. then
  638. echo "dtscr: usage: dtscr <command ...>"
  639. return 1
  640. fi
  641. ___cmdstr="`echo $@ | tr ' ' +`"
  642. ___tformat="%Y%m%d-%H%M%S%z"
  643. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  644. ___scr_file="${HOME}/${___name}.script"
  645. ___dt_dir="${TMP}/dtscr"
  646. mkdir -p "$___dt_dir"
  647. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  648. # echo $_name
  649. # echo $_file
  650. }
  651. mcrypt_stream(){
  652. test $# -eq 2 || return 1
  653. case $1 in
  654. en)
  655. mcrypt --key $2 | base64 ;;
  656. de)
  657. base64 -d | mcrypt -d --key $2 ;;
  658. esac
  659. }
  660. gpg_stream(){
  661. test $# -eq 2 || return 1
  662. case $1 in
  663. en)
  664. gpg --passphrase $2 -c --batch |base64 ;;
  665. de)
  666. base64 -d|gpg --passphrase $2 -d --batch ;;
  667. esac
  668. }
  669. dgpg(){
  670. if test "$1" = help || test -z "$2"
  671. then
  672. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  673. return
  674. fi
  675. ___srcs="$2"
  676. ___dsts="$3"
  677. test -z "$___dsts" && ___dsts="${___srcs}.out"
  678. ___pw=
  679. echo -n "dgpg pw: "
  680. read -s ___pw
  681. echo ""
  682. test -z "$___pw" && return 1
  683. for f in *${___srcs}
  684. do
  685. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  686. echo -n "Processing $f to $___d..."
  687. if test -d "$f"
  688. then
  689. echo "`printf 'failed (%s is directory)' $f`"
  690. elif test -f "$___d"
  691. then
  692. echo "`printf 'failed (%s is already exists)' $___d`"
  693. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  694. then
  695. echo "done"
  696. else
  697. echo "failed"
  698. test -f "$___d" && rm "$___d"
  699. fi
  700. done
  701. }
  702. alias enst="gpg_stream en"
  703. alias dest="gpg_stream de"
  704. showinfo(){
  705. echo "Japanese letters are 表示可能"
  706. __safe_run diskinfo
  707. ! $isdarwin && test -n "${DISPLAY}" && {
  708. __safe_run xrandr | \grep --color=never ^Screen
  709. }
  710. $iswindows || __safe_run finger $USER
  711. LANG=C __safe_run id
  712. __safe_run xset q
  713. }
  714. x(){
  715. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  716. #mkdir -p ~/.var/log
  717. # nohup startx >~/.var/log/xorg.log 2>&1 &
  718. # exit
  719. exec startx
  720. else
  721. echo "X cant be started! Another X is already running?" 1>&2
  722. fi
  723. }
  724. bak(){
  725. for file in "$@"
  726. do
  727. cp -v ${file} ${file}.bak
  728. done
  729. }
  730. di(){
  731. if null type git
  732. then
  733. git --git-dir= diff "$@"
  734. ___diffcmd="git --git-dir= diff"
  735. else
  736. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  737. then
  738. ___diffcmd=colordiff
  739. else
  740. ___diffcmd=diff
  741. fi
  742. ${___diffcmd} -u "$@" | ${PAGER}
  743. fi
  744. }
  745. __trash_func(){
  746. __datenum=`date +%Y%m%d-%H%M%S`
  747. __tb="$HOME/.var/tb/$__datenum"
  748. mkdir -p "$__tb"
  749. mv "$@" "$__tb"
  750. }
  751. __safe_alias tb=__trash_func
  752. __safe_alias tb=trash
  753. mkdd(){
  754. _d=`date +%Y%m%d-%H%M%S` && \
  755. mkdir -p "$_d"
  756. }
  757. mkcd(){
  758. if test -z "$1"
  759. then
  760. echo "mkcd: usage: mkcd <dir>"
  761. return 1
  762. elif test -d "$1"
  763. then
  764. echo "Dir \"$1\" already exists."
  765. else
  766. mkdir -p "$1"
  767. echo "Dir \"$1\" created."
  768. fi
  769. cd "$1"
  770. }
  771. mkcdd(){
  772. # make and change date directory
  773. _d=`date +%Y%m%d-%H%M%S` && \
  774. mkcd "$_d"
  775. }
  776. if test -n "$TMUX" && null type reattach-to-user-namespace
  777. then
  778. alias pbpaste="reattach-to-user-namespace pbpaste"
  779. alias pbcopy="reattach-to-user-namespace pbcopy"
  780. fi
  781. __catclip(){
  782. if $iswindows
  783. then
  784. cat /dev/clipboard | tr -d \\r
  785. elif $isdarwin
  786. then
  787. pbpaste
  788. else
  789. xclip -o -selection "clipboard"
  790. fi
  791. }
  792. __setclip(){
  793. if test $# -eq 0
  794. then
  795. exec 3<&0
  796. else
  797. exec 3<<__EOF__
  798. `cat "$@"`
  799. __EOF__
  800. fi
  801. if $iswindows
  802. then
  803. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  804. elif $isdarwin
  805. then
  806. pbcopy 0<&3
  807. else
  808. 0<&3 xclip -i -f -selection "primary" | \
  809. xclip -i -f -selection "clipboard"
  810. fi
  811. exec 3<&-
  812. }
  813. # Now Homebrew 10sr/pkg/bin provides these commands:
  814. # Fallback to aliases if commands are not installed yet
  815. which catclip >/dev/null || alias catclip=__catclip
  816. which setclip >/dev/null || alias setclip=__setclip
  817. convmv_sjis2utf8_test(){
  818. convmv -r -f sjis -t utf8 *
  819. }
  820. convmv_sjis2utf8_notest(){
  821. convmv -r -f sjis -t utf8 * --notest
  822. }
  823. #################################################
  824. ## pastebin services
  825. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  826. sprunge(){
  827. # http://sprunge.us
  828. if test -z "$1"
  829. then
  830. curl -F 'sprunge=<-' http://sprunge.us
  831. else
  832. curl http://sprunge.us/$1
  833. fi
  834. }
  835. dpaste(){
  836. # http://dpaste.de
  837. if test -z "$1"
  838. then
  839. curl -F 'content=<-' https://dpaste.de/api/
  840. echo
  841. else
  842. curl https://dpaste.de/$1/raw/
  843. fi
  844. }
  845. ######################################
  846. ## Prompt Settings
  847. __my_moc_state(){
  848. type mocp >/dev/null 2>&1 || return
  849. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  850. printf "$1" "`mocp -Q %title 2>/dev/null`"
  851. }
  852. __my_parse_svn_branch() {
  853. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  854. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  855. sed -ne 's#^Repository Root: ##p')
  856. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  857. awk '{print $1}'
  858. }
  859. __my_svn_ps1(){
  860. if svn status >/dev/null 2>&1
  861. then
  862. ___svn_branch=$(__my_parse_svn_branch)
  863. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  864. fi
  865. }
  866. __my_battery_status(){
  867. ___dir=/sys/class/power_supply/BAT0
  868. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  869. test -r $___dir/charge_now
  870. then
  871. ___st=$(cat $___dir/status)
  872. ___full=$(cat $___dir/charge_full)
  873. ___now=$(cat $___dir/charge_now)
  874. ___rate=$(expr "$___now" \* 100 / "$___full")
  875. printf "$1" "${___st}:${___rate}%"
  876. fi
  877. }
  878. __my_ps1_scale(){
  879. if null type stty && ! $ismsys
  880. then
  881. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  882. fi
  883. }
  884. __my_ps1_tmux(){
  885. null type tmux || return $last
  886. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  887. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  888. }
  889. __my_ps1_moc(){
  890. __my_moc_state "[MOC:%s]"
  891. }
  892. for f in /usr/share/git/git-prompt.sh \
  893. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  894. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  895. "`brew --prefix 2>/dev/null`"/etc/bash_completion.d/git-prompt.sh \
  896. /usr/share/git-core/contrib/completion/git-prompt.sh \
  897. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  898. /etc/bash_completion.d/git-prompt \
  899. /opt/local/share/git-core/git-prompt.sh \
  900. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  901. do
  902. if test -r "$f" && ($inbash || $inzsh)
  903. then
  904. . "$f"
  905. break
  906. fi
  907. done
  908. export GIT_PS1_SHOWDIRTYSTATE=t
  909. export GIT_PS1_SHOWUPSTREAM=t
  910. __my_ps1_git(){
  911. null type __git_ps1 || return $last
  912. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  913. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  914. }
  915. __printf_ipaddr(){
  916. # ipaddress <fmt>
  917. type ip >/dev/null 2>&1 || return 1
  918. ___ip=$(LANG=C ip addr show scope global | \
  919. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  920. test -n "$___ip" && printf "$1" $___ip
  921. }
  922. alias addr="__printf_ipaddr '%s'"
  923. __my_ps1_ipaddr(){
  924. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  925. }
  926. __my_ps1_bttry(){
  927. ___bst="$__homerun/batterystatus"
  928. if test -z "$DISPLAY" && ! $iswindows
  929. then
  930. test -f $___bst && ___bstr="$(cat $___bst)"
  931. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  932. echo "[Battery:${___bstr}]"
  933. __my_battery_status %s >$___bst &
  934. fi
  935. }
  936. __my_ps1_memo(){
  937. test -f memo.txt && echo "m:$(echo $(wc -c memo.txt) | cut -f 1 -d " ")"
  938. }
  939. __my_ps1_dirs(){
  940. dirs | wc -l
  941. }
  942. __my_ps1_jobs(){
  943. # __my_ps1_jobs [<num>]
  944. if test -n "$1"
  945. then
  946. jobs="$1"
  947. else
  948. jobs="`jobs | wc -l`"
  949. fi
  950. if test "$jobs" -gt 0
  951. then
  952. echo "JOBS:$jobs"
  953. fi
  954. }
  955. __my_ps1_dollar(){
  956. if test -z "$SHLVL"
  957. then
  958. printf "$1"
  959. else
  960. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  961. fi
  962. }
  963. __my_alert_fail(){
  964. test $laststatus -eq 0 || \
  965. echo "STATUS:${laststatus}"
  966. }
  967. # About ansi escape sequences
  968. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  969. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  970. if $inbash || $inzsh
  971. then
  972. if $inzsh
  973. then
  974. __attr_beg=$'%{\033['
  975. __attr_end='m%}'
  976. else
  977. __attr_beg='\[\033['
  978. __attr_end='m\]'
  979. fi
  980. __color_default="${__attr_beg}0${__attr_end}"
  981. __color_black="${__attr_beg}0;30${__attr_end}"
  982. __color_red="${__attr_beg}0;31${__attr_end}"
  983. __color_green="${__attr_beg}0;32${__attr_end}"
  984. __color_yellow="${__attr_beg}0;33${__attr_end}"
  985. __color_blue="${__attr_beg}0;34${__attr_end}"
  986. __color_magenta="${__attr_beg}0;35${__attr_end}"
  987. __color_cyan="${__attr_beg}0;36${__attr_end}"
  988. __color_white="${__attr_beg}0;37${__attr_end}"
  989. __color_light_black="${__attr_beg}1;30${__attr_end}"
  990. __color_light_red="${__attr_beg}1;31${__attr_end}"
  991. __color_light_green="${__attr_beg}1;32${__attr_end}"
  992. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  993. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  994. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  995. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  996. __color_light_white="${__attr_beg}1;37${__attr_end}"
  997. __color_bg_black="${__attr_beg}40${__attr_end}"
  998. __color_bg_red="${__attr_beg}41${__attr_end}"
  999. __color_bg_green="${__attr_beg}42${__attr_end}"
  1000. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1001. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1002. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1003. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1004. __color_bg_white="${__attr_beg}47${__attr_end}"
  1005. __attr_underline="${__attr_beg}4${__attr_end}"
  1006. __attr_reverse="${__attr_beg}7${__attr_end}"
  1007. __attr_bold="${__attr_beg}1${__attr_end}"
  1008. fi
  1009. # NOTE: tput is another easy way to set colors and background
  1010. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1011. # color blue.
  1012. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1013. if test "$TERM" != dumb
  1014. then
  1015. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1016. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1017. # color for ::
  1018. if test -z "$_HOSTCOLOR_1"
  1019. then
  1020. # default color used by tmux status line
  1021. _HOSTCOLOR_1=green
  1022. fi
  1023. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1024. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1025. __my_cdef="$__color_default"
  1026. fi
  1027. if $inbash
  1028. then
  1029. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1030. elif $inzsh
  1031. then
  1032. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1033. fi
  1034. __my_ps1_info1(){
  1035. # first line of PS1
  1036. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1037. }
  1038. test -n "$__MY_SCRIPT" && \
  1039. __my_ps1_str_scr="SCR"
  1040. test -n "$SSH_CONNECTION" && \
  1041. __my_ps1_str_ssh="SSH"
  1042. test -n "$__MY_DTACH" && \
  1043. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1044. __my_ps1_info2(){
  1045. # second line of PS1
  1046. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1047. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1048. | sed -e 's/ /|/g'
  1049. }
  1050. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1051. __my_ps1_save_pos="\[\033[s\]"
  1052. __my_ps1_restore_pos="\[\033[u\]"
  1053. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1054. __my_ps1_move_15left="\[\033[15D\]"
  1055. # collapse when command line is too long and try to write over this string
  1056. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1057. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1058. if $inzsh
  1059. then
  1060. PROMPT="\
  1061. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1062. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1063. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1064. elif $inbash
  1065. then
  1066. PS1="\
  1067. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1068. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1069. else
  1070. true
  1071. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1072. fi
  1073. ###################################
  1074. # set header and titles
  1075. __my_set_header_line(){
  1076. # save current position
  1077. printf "\033[s"
  1078. # move to 0,0
  1079. printf "\033[0;0H"
  1080. # clear curent to eol
  1081. printf "\033[K"
  1082. # inverse color
  1083. printf "\033[7m"
  1084. printf "$1"
  1085. # restore color
  1086. printf "\033[0m"
  1087. # restore saved position
  1088. printf "\033[u"
  1089. }
  1090. __my_set_screen_name(){
  1091. # set window name
  1092. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1093. then
  1094. echo -ne "\033k$1\033\\"
  1095. fi
  1096. }
  1097. __my_set_title(){
  1098. case $TERM in
  1099. (rxvt*|xterm*|aterm|screen*)
  1100. test -t 1 &&
  1101. test -z "$EMACS" &&
  1102. echo -n -e "\033]0;$1\007"
  1103. ;;
  1104. esac
  1105. }
  1106. if test -n "$TMUX"
  1107. then
  1108. # running tmux locally
  1109. __terminal_title="\$(basename \${PWD})"
  1110. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1111. then
  1112. # ssh connect from tmux terminal
  1113. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1114. else
  1115. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1116. fi
  1117. if $inzsh
  1118. then
  1119. precmd(){
  1120. laststatus=$?
  1121. eval __my_set_title ${__terminal_title}
  1122. }
  1123. else
  1124. if test -n "$PROMPT_COMMAND" && ! expr "$PROMPT_COMMAND" : '.*; *$' >/dev/null
  1125. then
  1126. PROMPT_COMMAND="${PROMPT_COMMAND};"
  1127. fi
  1128. if test -n "$PROMPT_COMMAND"
  1129. then
  1130. PROMPT_COMMAND="laststatus=\$?;${PROMPT_COMMAND}__my_set_title \"${__terminal_title}\";"
  1131. else
  1132. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";"
  1133. fi
  1134. fi
  1135. laststatus=0